require "camping"
require "fileutils"
require "markaby"
require "pathname"

Camping.goes :Plemp

Markaby::Builder.set(:indent, 2)
PUBLIC_DIR = Pathname.new(__FILE__).dirname + "public"
UPLOAD_DIR = Pathname.new(__FILE__).dirname + "upload"

module Plemp::Controllers

  class Index
    def get
      render :main
    end
  end

 class PublicX
    MIME_TYPES = {'.css' => 'text/css',
                  '.js'  => 'text/javascript', 
                  '.jpg' => 'image/jpeg'}

    def get(path)
      @headers['Content-Type'] = MIME_TYPES[path[/\.\w+$/, 0]] || "text/plain"
      unless path.include? ".." # prevent directory traversal attacks
        @headers['X-Sendfile'] = "#{PUBLIC_DIR}/#{path}"
      else
        @status = "403"
        "403 - Invalid path"
      end
    end
  end 

  class SaveposXXX
    def post(id, top, left)
      $stderr.puts("Got: top: #{top}, left: #{left}")
      ""
    end
  end

  class Upload
    def post
      orig_ext = File.extname(@input.file[:filename])
      new_file = UPLOAD_DIR + Time.now.strftime("%Y%m%d%H%M%S#{orig_ext}")
      new_file.open("w") do |f|
        f.write(@input.file[:tempfile].read)
      end
      redirect Index
    end
  end

end

module Plemp::Views

  def layout
    xhtml_strict do
      head do
        title "Plemp!"
        ['drag', 'prototype', 'effects', 'controls'].each do |js|
          script :src => R(PublicX, "#{js}.js"), :type => "text/javascript"
        end
      end
      body do
        self << yield
      end
    end
  end

  def main
    form :action => R(Upload), :method => "post",
         :enctype => "multipart/form-data" do
      p do 
        input :name => "file", :id => "file", :type => "file"
        input :type => "submit", :value => "Upload!"
      end
    end
    div.first!  :style => "position:absolute;top:120px;left:100px",
                :onmousedown => "drag(event)" do "First" end
    div.second! :style => "position:absolute;top:170px;left:300px",
                :onmousedown => "drag(event)",
                :onmouseup => _savepos do "Second" end
  end

  def _savepos
    "new Ajax.Request('http://localhost:3301/savepos/' + " +
    "this.id + '/' + this.style.top + '/' + this.style.left); " +
    "return false;"
  end


end
